<?php

###### Standard sub-routines #######

########### Check for all required fields :

function required_check()
{
	global $formData;

	global $required;
	if((!is_array($required) || count($required) == 0) && isset($formData['required_form_fields']))
	{
		$required = explode(",", $formData['required_form_fields']);
	}

	if(is_array($required))
	{
		$isFirst = TRUE;
		$needsMore = FALSE;
		foreach($required as $field)
		{
			if(!isset($formData[$field]) || !$formData[$field])
			{
				$needsMore = TRUE;
				$value = $formData[$field];
				$value = str_replace('_', ' ', $value);

				if($isFirst)
				{
					HTMLHeader();
					print "<center><h3>Error - Missing Form Information! </h3><br></center>\n";
					print "It seems that you've forgotten to fill out the following information:\n";
					print "<ul>\n";
				}
				print "<li><b><FONT COLOR=\"#FF0000\">$field</FONT></b></li>";
				$isFirst = FALSE;
			}
		}
		if($needsMore)
		{
			print "</ul>\n";
			print "Please use your browser's back button and correct this.\n";
			print "Thank You.</P>\n";
			print "<HR ALIGN=LEFT>\n";
			HTMLFooter();
			exit();
		} else
		{

		}
	}
}

############## Check the senders' email :

function email_check()
{
	global $formData;
	$email = isset($formData['Email']) ? $formData['Email'] : '';
	if(! preg_match("/.+@.+\..+/", $email) )
	{
		HTMLHeader();
		print "<h3><center>Email Address Error!</center></h3>\n";
		print "The email address that you've entered: ";
		print "<b><FONT COLOR=\"#FF0000\">".$formData['Email']."</FONT></b>, ";
		print "is not quite correct. ";
		print "Please use your browser's back button and correct it. ";
		print "Thank you.\n";
		HTMLFooter();
		exit();
	}
}


################### Print output page header text from file

function HTMLHeader()
{
	global $formData, $path_to_data_files;

	if(!headers_sent())
	{
		header("Content-Type: text/html");
	}

	$header = $formData['header_file'];
	if (!$header) {
		$header = "data/myheader.html";
	}

	$handle = @fopen("$path_to_data_files/".$header, "r");
	if($handle)
	{
		while(!feof($handle))
		{
			$line = fgets($handle, 1024);
			echo $line."\r\n";
		}
		fclose($handle);
	}
}

################## Print output page footer text from file:

function HTMLFooter()
{
	global $formData, $path_to_data_files;

	$footer = $formData['footer_file'];
	if (!$footer) {
		$footer = "data/myfooter.html";
	}

	$handle = @fopen("$path_to_data_files/".$footer, "r");
	$gotIt = FALSE;
	if($handle)
	{
		while(!feof($handle))
		{
			$line = fgets($handle, 1024);
			if(stristr($line, 'edujini.in') >= 0)
			{
				$gotIt = TRUE;
			}

			echo $line."\r\n";
		}
		fclose($handle);
	}

	if(!$gotIt)
	{
		$data = "<center><FONT SIZE=1><a target='_blank' href='http://www.ttfreeware.com'>TigerTom's Form Mailer</a> "
				."</center>";
		echo $data;
	}

}


############################# Valid referrer check:

function referer_check()
{
	$invalid_referer = 1;
	global $valid_urls;

	if(count($valid_urls) == 0)
	{
		$invalid_referer = 0;
	}
	if(isset($_SERVER['HTTP_REFERER']))
	{

		$referer = strtolower($_SERVER['HTTP_REFERER']);
		foreach($valid_urls as $valid)
		{
			$pat = 'http://'.$valid;
			if(stristr($referer,$pat))
			{
				$invalid_referer = 0;
				break;
			}
			$pat = 'https://'.$valid;
			if(stristr($referer,$pat))
			{
				$invalid_referer = 0;
				break;
			}
		}
	} else {
		$invalid_referer = 0;
	}
	if ($invalid_referer == 1)
	{
		HTMLHeader();
		print "<H2>Error! Bad referer [".$_SERVER['HTTP_REFERER']."]</H2>\n";
		HTMLFooter();
		exit();
	}
}

############################# hack attempt notifier:

function hack_alert($type,$data)
{
	global $webmaster, $subject;

	$hsubject = $subject . " - Hack attempt detected";

	$headers = 'From: '.$webmaster."\r\n";

	$message = "Hack attempt detected."."\r\n\r\n";

	switch ($type) {
		case 'emailinjection':
			$message .= "Email Injection - http://www.securephpwiki.com/index.php/Email_Injection"."\r\n";
			$message .= $data . "\r\n\r\n";
			$short = " (Email Injection)";
			break;
		case 'querystring':
			$message .= "Querystring too long."."\r\n";
			$message .= $data . "\r\n\r\n";
			$short = " (Bad Querystring)";
			break;
		default:
			$short = "";
			break;
	}

	$message .= "Environmental (server and browser) variables :\r\n";
	$message .= "IP Number     : ".$_SERVER['REMOTE_ADDR']."\r\n";
	$message .= "Browser       : ".$_SERVER['HTTP_USER_AGENT']."\r\n";
	if(isset($_SERVER['HTTP_FORWARDED']))
	{
		$message .= "Proxy         : ".$_SERVER['HTTP_FORWARDED']."\r\n";
	}
	if(isset($_SERVER['HTTP_COOKIE']))
	{
		$message .= "Cookie        : ".$_SERVER['HTTP_COOKIE']."\r\n";
	}
	$message .= "Time:         : ".date("r")."\r\n";

	sendMail($webmaster, $hsubject, $message, $headers);

	HTMLHeader();
	print "<H2>Error! Hack attempt detected".$short.". Webmaster has been notified.</H2>\n";
	HTMLFooter();
	exit();
}

############################# sendMail with params adjust

function sendMail($to, $subject, $message, $headers)
{
	# replace all \r\n in $message
	$message = str_replace("\r\n","\n",$message);

	# note: $message goes to $headers if sent with attachments, look for placeholder...
	if (strstr($headers,"[put_message_in_headers]") !== FALSE) {
		$headers = str_replace("[put_message_in_headers]",$message,$headers);
		# if mime-message, remove \r\n from headers for php
		$headers = str_replace("\r\n","\n",$headers);
		$message = "";
	}

	# remove tailing/leading \r\n
	$headers = trim($headers,"\r\n");

	@mail($to, $subject, $message, $headers);
}

?>